import os
import csv

import pytest
import psycopg2
from dotenv import load_dotenv


@pytest.fixture(scope="session")
def connection():
    load_dotenv(dotenv_path='../env/emg_db.env')

    connect_args = dict(
        dbname=os.environ['DB_NAME'],
        user=os.environ['DB_USER'],
        password=f"\"{os.environ['DB_PW']}\"",
        host='docker',
        port=os.environ['DB_PORT'],
    )

    with psycopg2.connect(**connect_args) as connection:
        yield connection


@pytest.fixture
def identifiers():
    with open('./product_list.csv') as f:
        yield csv.reader(f)


def query_eo_object(connection, eo_id):
    query = f"SELECT identifier FROM coverages_eoobject WHERE identifier = '{eo_id}';"
    with connection.cursor() as cursor:
        cursor.execute(query)
        return cursor.fetchone()[0]


def test_db_name(connection, identifiers):
    for row in identifiers:
        identifier = row[0].split('/')[4]
        query_eo_object(connection, identifier)
